rm(list=ls())

require(zoo)
require(xts)
require(lubridate)

# exercise 0: comparing WIG/WIG20/ETFWIG20

data <- read.csv("https://stooq.pl/q/d/l/?s=lpp&i=d")
str(data)
dates <- as.Date(data$Data)
P     <- data$Zamkniecie
require(zoo)
LPP <- zoo(P,dates)
plot(LPP)

data1 <- read.csv("https://stooq.pl/q/d/l/?s=wig20&i=d")
data2 <- read.csv("https://stooq.pl/q/d/l/?s=wig&i=d")
data3 <- read.csv("https://stooq.pl/q/d/l/?s=etfw20l.pl&i=d")
d1    <- as.Date(data1$Data); P1    <- data1$Zamkniecie; WIG20 <- zoo(P1,d1)
d2    <- as.Date(data2$Data); P2    <- data2$Zamkniecie; WIG   <- zoo(P2,d2)
d3    <- as.Date(data3$Data); P3    <- data3$Zamkniecie; ETFW20 <- zoo(P3,d3)
x <- merge(WIG,10*WIG20)
plot(x,screens=c(1,1),col=1:2)
x1 <- merge(WIG20,10*ETFW20, all=FALSE)
plot(x1,screens=c(1,1),col=1:2)

# Exercise 1.1
v0 = 5
m0 = 5
s0 = 20
H0 = 400

mH = H0*m0
sH = sqrt(H0)*s0

VaRa  <- mH + sH*qdist("std",shape=v0,p=0.05)
qf    <- function(x) qdist("std", p=x, shape=v0)
ESa   <- mH + sH*(1/p * integrate(qf, 0, p)$value) 

Nsim    <- 10000
Rdraws  <- matrix(rdist(distribution="std", Nsim*H0, mu = m0, sigma = s0, shape = v0),H0,Nsim) 
RdrawsC <- apply(Rdraws,2,cumsum)               # cumualted changes
M0  <- floor(Nsim*0.05)     # observation for p-th quantile 
temp   = sort(RdrawsC[H0,])
VaRb = temp[M0]
ESb  = mean(temp[1:M0])

c(VaRa,VaRb)

VaRc  <- mH + sH*qdist("norm",p=0.05)

c(VaRa,VaRb, VaRc)
